// Copyright (C) 2008
// by all contributors.

// This file is part of SCNSL.

// SCNSL is free software:
// you can redistribute it and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option)
// any later version.

// SCNSL is distributed in the hope
// that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.
// See the GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with SCNSL,
// in a file named LICENSE.txt.
// If not, see <http://www.gnu.org/licenses/>.



/// @file
/// Core topology setup.



#include "scnsl/builtinPlugin/CoreTopologySetup_t.hh"


using namespace Scnsl::BuiltinPlugin;


// ////////////////////////////////////////////////////////////////
// Constructor and destructor.
// ////////////////////////////////////////////////////////////////

CoreTopologySetup_t::CoreTopologySetup_t():
    // Parents:
    Scnsl::Setup::TopologySetup_base_t(),
    // Fields:
    topology_type( BOTTLENECK ),
    node_factory_infos(),
    channel_list(),
    bind_list()
{
    // Nothing to do.
}


CoreTopologySetup_t::~CoreTopologySetup_t()
{
    // Nothing to do.
}


