
#ifndef SCNSL__TASK_ROUTER2_HH
#define SCNSL__TASK_ROUTER2_HH



/// @file
/// Router node.


#include <systemc>
#include <tlm.h>


// Including the library:
#include <scnsl.hh>



class TaskRouter2 :
    public Scnsl::Tlm::TlmTask_if_t
{

public:

    SC_HAS_PROCESS( TaskRouter2 );

    /// @brief Constructor.
    ///
    /// @param name This module name.
    /// @param id this module unique ID.
    /// @param n The node on which this task is placed.
    /// @param proxies The number of connected task proxies.
    /// @throw std::invalid_argument If proxies is zero.
    ///
	TaskRouter2( sc_core::sc_module_name name,
            	const task_id_t id,
            	Scnsl::Core::Node_t * n,
            	const size_t proxies );

    virtual ~TaskRouter2();

	virtual void b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t );

protected:

    /// @name Processes.
    //@{

    void writingProcess();

    //@}

private:

    TaskRouter2( TaskRouter2 & );

    TaskRouter2 & operator = ( TaskRouter2 & );

};

#endif

