 


#ifndef MySensor_t_HH
#define MySensor_t_HH

#include <systemc>
#include <scnsl.hh>
 
class MySensor_t:
    public Scnsl::Tlm::TlmTask_if_t
{
public:

    SC_HAS_PROCESS( MySensor_t );
    MySensor_t( const sc_core::sc_module_name modulename,
              const task_id_t id,
              Scnsl::Core::Node_t * n,
              const size_t proxies );

    /// @brief Virtual destructor.
    virtual
    ~MySensor_t();

    /// @name Inherited interface methods.
    //@{


    virtual
    void b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t );

    //@}

    /// @brief Signals when a packet is arrived.
    sc_core::sc_event _packetArrivedEvent;
    unsigned int taskid;
private:

    /// @name Processes.
    //@{

    /// @brief Sender process.
    void _sender();
 


    /// @brief Disabled copy constructor.
    MySensor_t( const MySensor_t & );

    /// @brief Disabled assignment operator.
    MySensor_t & operator = ( MySensor_t & );
};



#endif

