
#ifndef SCNSL__MY_TASK_SENDER_HH
#define SCNSL__MY_TASK_SENDER_HH



/// @file
/// Source node.


#include <systemc>

// Allowing Scnsl::Rtl::LinkNode_t usage:
//#define SCNSL__TLM__USE_LINK_NODE_HH

// Including the library:
#include <scnsl.hh>



class MyTaskSender :
    public Scnsl::Rtl::RtlTask_if_t<8>
{

public:

    SC_HAS_PROCESS( MyTaskSender );

    /// @brief Constructor.
    ///
    /// @param name This module name.
    /// @param id this module unique ID.
    /// @param n The node on which this task is placed.
    /// @param proxies The number of connected task proxies.
    /// @throw std::invalid_argument If proxies is zero.
    ///
	MyTaskSender( sc_core::sc_module_name name,
                  const task_id_t id,
                  Scnsl::Core::Node_t * n,
                  const size_t proxies );


protected:

    /// @name Processes.
        //@{

    void writingProcess();

    void carrierProcess();

        //@}

private:

    MyTaskSender( MyTaskSender & );

    MyTaskSender & operator = ( MyTaskSender & );

};

#endif

